<template>
  <div class="columns four" style="position: relative">
    <label for="email">Электронная почта</label>
    <input :class="[getValidateClass('email'), {'data-processing': SUGGESTIONS_LOADER.email}]"
           type="email"
           name="email"
           id="email"
           @input="input"
           v-validate="'required|email'"
           @click="changeTitle"
           @blur="returnTitle"
           v-model="$user.email"
           autocomplete="off"
           @keyup.down="nextSuggestion"
           @keyup.up="prevSuggestion"
           @keyup.tab="nextSuggestion"
           @keyup.esc="suggestions = []"
           @keyup.enter="setSuggestion"
           data-code="emailAddressInvalidFormat, emailAddressInvalidHostname, emailAddressInvalidMxRecord, emailDomainInBlackList"
    >
    <ul v-if="suggestions.length" class="options-list">
      <li v-for="(email, index) in suggestions"
          @click="setSuggestion(index)"
          :class="{'highlighted': index === selectedSuggestion}"
          v-html="email && email.value ? hl(email.value) : ''">
      </li>
    </ul>
    <validate-message v-show="vErrors.has('email')">
      {{ vErrors.first('email') }}
    </validate-message>
  </div>
</template>

<script>
  import ValidateMessage from '@/components/Validators/ValidateMessage'
  import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
  import { REQUIRED_FIELD, MIN_LENGHT, MAX_LENGHT } from '@/components/Validators/CustomVeeValidateMessage'
  import UserGetter from '@/mixins/User/UserGetterMixin'
  import UserSetter from '@/mixins/User/UserSetterMixin'
  import UserErrorText from '@/mixins/User/UserErrorTextMixin'
  import IndicatorRegistration from '@/mixins/IndicatorRegistration'
  import ErrorHandleMixin from '@/mixins/ErrorHandleMixin'
  import debounce from 'lodash/debounce'
  import Diff from '@/utils/diff.js'
  import {mapGetters} from 'vuex'
  const diff = new Diff()
  let request;
  export default {
    data: function () {
      return {
        title: 'электронная почта',
        // suggestions: [],
        selectedSuggestion: -1,
        display: true
      }
    },
      computed: {
        suggestions () {
            return this.$store.getters.SUGGESTIONS_GET_EMAIL_LIST;
        },
        ...mapGetters(['SUGGESTIONS_LOADER'])
      },
    watch: {
      '$user.email': debounce(async function () {
        if (this.$user.email && this.$user.email.indexOf('@') && this.display && this.noSuggestions === false) {

            this.$store.commit('SUGGESTIONS_SET_LOADER', {email: true}); // включаем лоадер, пока грузяться данные

            if(request) {
                request.abort(); // отменяем предыдующие запросы, если запросы не успели подгрузиться
            }

            request = await this.$store.dispatch('SUGGESTIONS_GET_EMAIL', this.$user.email);

            request.onreadystatechange = function () {
                // результат на то, что email введен верно
                if(request.readyState === XMLHttpRequest.DONE && request.status === 200) {
                    this.$store.commit('SUGGESTIONS_SET_EMAIL_LIST', request.response);
                    this.$store.commit('SUGGESTIONS_SET_LOADER', {email: false});
                    request = null;
                }
            }.bind(this);
        }
      }, 500),

      display (state) {
        if (!state) {
          this.selectedSuggestion = -1
        }
      }
    },
    props: {
      'no-suggestions': {
        type: Boolean,
        default: false
      }
    },
    mixins: [
      UserGetter,
      UserSetter,
      UserErrorText,
      GetValidateClass,
      IndicatorRegistration,
      ErrorHandleMixin
    ],
    mounted: function () {
      this.$validator.localize(REQUIRED_FIELD)
      this.$validator.localize(MIN_LENGHT)
      this.$validator.localize(MAX_LENGHT)
    },
    methods: {
      hl (value) {
        return diff.prettyHtml(diff.main(this.$user.email, value))
      },
      changeTitle () {
        this.title = ''
      },
      returnTitle () {
        setTimeout(() => {
          this.title = 'электронная почта'
          this.$store.commit('SUGGESTIONS_TRUNCATE_EMAIL');
          this.display = false
        }, 100)
      },
      input () {
        this.display = true
        if (this.suggestions[this.selectedSuggestion]) {
          this.$emit('input', this.suggestions[this.selectedSuggestion].value)
        }

        this.$user.validate.step1.contactEmail = Object.keys(this.$validator.flags).reduce((acc, item) => acc && this.$validator.flags[item].valid, true)
      },
      nextSuggestion (e) {
        if (e.key === 'Tab' && this.suggestions.length) {
          e.preventDefault()
        }
        let index = this.selectedSuggestion + 1
        if (index >= this.suggestions.length) {
          this.selectedSuggestion = 0
        } else {
          this.selectedSuggestion = index
        }
      },
      prevSuggestion () {
        let index = this.selectedSuggestion - 1
        if (index < 0) {
          this.selectedSuggestion = this.suggestions.length - 1
        } else {
          this.selectedSuggestion = index
        }
      },
      setSuggestion (index) {
        if (index !== undefined && typeof index === 'number') {
          this.selectedSuggestion = index
        }
        if (this.selectedSuggestion === -1) {
          this.$store.commit('SUGGESTIONS_TRUNCATE_EMAIL');
          this.display = false
          return
        }
        this.$user.email = this.suggestions[this.selectedSuggestion].value
        this.store.commit('SUGGESTIONS_TRUNCATE_EMAIL');
        this.display = false
      }
    },
    components: {
      ValidateMessage
    },
    updated () {
      this.$user.validate.step1.contactEmail = Object.keys(this.$validator.flags).reduce((acc, item) => acc && this.$validator.flags[item].valid, true)
    },

  }
</script>

<style scoped lang="scss">
  .disabled {
    color: darkGray;
    cursor: default;
  }

  ::-webkit-input-placeholder {
    color: #DED3D3;
  }

  ::-moz-placeholder {
    color: #DED3D3;
  }

  :-ms-input-placeholder {
    color: #DED3D3;
  }

  :-moz-placeholder {
    color: #DED3D3;
  }

</style>

